# $Id: Tool.py,v 1.2 2005/12/08 16:25:57 asc Exp $

import os
import codecs
import sys
import wx
import tempfile

from ImageWidgetSpeechTool.Constants import *

class SpeechTool :

    def Setup (self, frame) :

        self.__lastspoken = [];
        
        SpeechMenu = wx.Menu()

        SpeechMenu.Append(SPEECH_ID_SPEAK,
                          SPEECH_MENU_SPEAK,
                          SPEECH_DESCRIBE_SPEAK)

        wx.EVT_MENU(frame,
                    SPEECH_ID_SPEAK,
                    self.SpeakPhoto)

        menu = frame.GetMenuBar()
        menu.Append(SpeechMenu, SPEECH_MENU_LABEL)

        if sys.platform!='darwin' :
            menu.Enable(SPEECH_ID_SPEAK, False)
            
    #
    #
    #
    
    def SpeechKeyDown (self, key, event=None) :

        if key == "S" :

            if event==None:
                return True

            if event.ShiftDown() :
                self.SpeakPhoto(event)
            
        else :
            return False

    #
    #
    #
    
    def SpeakPhoto (self, event) :

	try :
	    photo = self.GetCurrentPhoto()
	except Exception, e:
	    self.ReportError(e)
	    return False

        self.__speak(u"%s. %s" % (photo['title'],photo['description']))

        return True

    #
    #
    #
    
    def __speak (self, raw) :

        for f in self.__lastspoken :
            if os.path.isfile(f) :
                os.unlink(f)
            self.__lastspoken.remove(f)
            
        # txt = raw.encode('ascii','replace')
        
        platform=sys.platform
        
        if platform=='darwin' :

            (fd,fname) = tempfile.mkstemp()
            fh         = codecs.open(fname, "w", "utf-8")

            fh.write(raw)

            # FIX ME : sort out how to spawn
            # with a process ID that can be killed
            # when the next photo is displayed
            
            os.system(u"say -v Fred -f %s &" % fname)
            fh.close()
                
            self.__lastspoken.append(fname)
            return True
        else :

            # For future reference :
            # import win32api
            # win32api.TerminateProcess(pid,0)

            self.ReportError("%s is not a supported platform for the speech tool" % platform)
            return False

    #
    #
    #
